<template>
  <div class="w-full">
    <ValidationProvider
      v-slot="{ errors, ariaMsg, ariaInput }"
      :rules="rules"
      :immediate="false"
      onkeydown="return event.key != 'Enter';"
    >
      <div role="radiogroup" aria-labelledby="shipping_method_step">
        <label
          v-for="(content, i) in contents"
          v-bind="ariaInput"
          :id="'list' + i"
          :key="i"
          :aria-label="`${content.title} ${content.labeldescription} ${content.value}`"
          :aria-checked="selectedValue == content.title && !disabled ? true : false"
          :aria-rowindex="i"
          :for="'method_id' + i"
          class="focus:outline-none focus:ring-black border cursor-pointer rounded-md max-auto grid grid-cols-10 px-4 py-6 md:p-6 lg:text-base text-sm focus:ring-1"
          :class="[
            selectedValue == content.title && !disabled
              ? 'border-black'
              : 'border-grey-20',
            contents.length - 1 == i ? 'mt-4 md:mt-6' : 'my-4 md:my-6',
            !disabled ? 'focus:border-black' : '',
          ]"
          @click="handleClick(content)"
          @keypress.enter="handleClick(content)"
        >
          <input v-model="selected" type="hidden" />
				  <input name="method_list" role="radio" :aria-checked="selectedValue == content.title && !disabled" :tabindex="selectedValue == content.title && !disabled || (i == 0 && !selectedValue) ? 0 : -1" type="radio" :id="'method_id' + i" class="absolute opacity-0"/>
          <span
            class="font-primary-font-bold"
            aria-hidden="true"
            :class="
              content.description
                ? 'col-span-4 md:col-span-4 lg:col-span-4'
                : 'col-span-5'
            "
            >{{ content.title }}</span
          >
          <span
            v-if="content.description"
            class="font-primary-font-light col-span-4 md:col-span-4 lg:col-span-5"
            aria-hidden="true"
            >{{ content.description }}</span
          >
          <span
            aria-hidden="true"
            class="font-primary-font-light text-right"
            :class="
              content.description
                ? 'col-span-2 md:col-span-2 lg:col-span-1 '
                : 'col-span-5'
            "
            >{{ content.value }}</span
          >
        </label>
      </div>
      <p v-show="errors" class="text-error-20 text-sm" v-bind="ariaMsg">
        {{ errors[0] }}
      </p>
    </ValidationProvider>
  </div>
</template>
<script>
import { ValidationProvider } from 'vee-validate'
export default {
  name: 'MKListRecord',
  components: {
    ValidationProvider,
  },
  props: {
    contents: {
      type: [Array, Object],
      default: () =>[],
    },
    selected: {
      type: String,
      default: '',
    },
    disabled: {
      type: Boolean,
      default: false,
    },
    rules: {
      type: String,
      default: '',
    },
  },
  mounted(){
    this.focusList();
  },
  computed: {
    selectedValue() {
      if (!this.disabled) {
        return this.selected
      } else {
        return ''
      }
    },
  },
  methods: {
    focusList(){
      if(this.contents && this.contents.length){
        let $content = this.contents[0]
        this.selected = $content.title
        this.$emit('selected', $content)
      }

    },
    handleClick($content) {
      if (!this.disabled) {
        this.selected = $content.title
        this.selectedValue = $content.title
        this.$emit('selected', $content)
      }
    },
  },
}
</script>
<style lang="postcss">
.icon-notification:before {
  @apply text-grey-20;
}
.mk-tooltip:focus > .mk-tooltip-text {
  display: block;
}
</style>
